Attribute VB_Name = "FinWin"
Option Explicit
Declare Function GetWindowTextLength Lib "user32" Alias "GetWindowTextLengthA" (ByVal hwnd As Long) As Long
Public Declare Function SetForegroundWindow Lib "user32" (ByVal hwnd As Long) As Long
Declare Function EnumWindows Lib "user32" _
  (ByVal lpEnumFunc As Long, ByVal lParam As Long) As Long
Declare Function EnumChildWindows Lib "user32" (ByVal hWndParent _
  As Long, ByVal lpEnumFunc As Long, ByVal lParam As Long) As Long
Declare Function GetClassName Lib "user32" Alias "GetClassNameA" _
  (ByVal hwnd As Long, ByVal lpClassName As String, _
  ByVal nMaxCount As Long) As Long
Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" _
  (ByVal hwnd As Long, ByVal lpString As String, _
  ByVal cch As Long) As Long

Public mTargetWinClass As String
Public mTargetWinCaption As String
Public mTargetSubClass As String
Public mTargetSubClassIndex As Integer
Public mSubFormHnd As Long

Dim IndexCount As Integer

Private m_TargetString As String
Private m_TargetHwnd As Long

Public Function EnumCallback(ByVal app_hWnd As Long, ByVal param As Long) As Long
   Dim buf As String
   Dim title As String
   Dim Length As Long

    Length = 255
    buf = String(Length, Chr$(0))
    Length = GetWindowText(app_hWnd, buf, Length)
    Length = InStr(1, buf, Chr$(0))
    title = Left$(buf, Length)

    If InStr(1, title, m_TargetString, vbTextCompare) <> 0 Then
        m_TargetHwnd = app_hWnd
        EnumCallback = 0
    Else
        EnumCallback = 1
    End If
End Function

Public Function FindWindowByPartialTitle(ByVal target_string As String) As Long
'Find a window with a title containing the target_string
    m_TargetString = target_string
    m_TargetHwnd = 0
    
    EnumWindows AddressOf EnumCallback, 0
    ' Return the hWnd found (if any).
    FindWindowByPartialTitle = m_TargetHwnd
End Function

Public Function StripNulls(OriginalStr As String) As String
'This removes any extra nulls so string comparisons will work
    If (InStr(OriginalStr, Chr(0)) > 0) Then
       OriginalStr = Left(OriginalStr, InStr(OriginalStr, Chr(0)) - 1)
    End If
    StripNulls = OriginalStr
End Function

Function EnumChildProc(ByVal lhWnd As Long, ByVal lParam As Long) As Long
   Dim retVal As Long
   Dim WinClassBuf As String * 255, WinTitleBuf As String * 255
   Dim WinClass As String, WinTitle As String

   retVal = GetClassName(lhWnd, WinClassBuf, 255)
   WinClass = StripNulls(WinClassBuf)  ' remove extra Nulls & spaces
   retVal = GetWindowText(lhWnd, WinTitleBuf, 255)
   WinTitle = StripNulls(WinTitleBuf)  ' remove extra Nulls & spaces
   'check to see if class is correct
   If LCase(WinClass) = LCase(mTargetSubClass) Then
'check to see if index is correct
      If IndexCount = mTargetSubClassIndex Then
'if both class and index are correct, then return hnd & exit
          mSubFormHnd = lhWnd
          EnumChildProc = False
          Exit Function
      Else
      IndexCount = IndexCount + 1
      End If
   End If
   EnumChildProc = True
End Function

Function FindSubWinds(ByVal lhWnd As Long, ByVal lParam As Long) As Long
Dim retVal As Long, ProcessID As Long, ThreadID As Long
Dim WinClassBuf As String * 255, WinTitleBuf As String * 255
Dim WinClass As String, WinTitle As String
   
   IndexCount = 1
   retVal = GetClassName(lhWnd, WinClassBuf, 255)
   WinClass = StripNulls(WinClassBuf)  ' remove extra Nulls & spaces
   retVal = GetWindowText(lhWnd, WinTitleBuf, 255)
   WinTitle = StripNulls(WinTitleBuf)
   
   If LCase(WinClass) = LCase(mTargetWinClass) And LCase(WinTitle) = LCase(mTargetWinCaption) Then
      retVal = EnumChildWindows(lhWnd, AddressOf EnumChildProc, lParam)
      FindSubWinds = False
      Exit Function
   End If
   
   FindSubWinds = True

End Function

Public Function FindPalRooms(ByVal lhWnd As Long, ByVal lParam As Long) As Long
Dim retVal As Long, ProcessID As Long, ThreadID As Long
Dim WinClassBuf As String * 255, WinTitleBuf As String * 255
Dim WinClass As String, WinTitle As String

    retVal = GetClassName(lhWnd, WinClassBuf, 255)
    WinClass = StripNulls(WinClassBuf)  ' remove extra Nulls & spaces
    retVal = GetWindowText(lhWnd, WinTitleBuf, 255)
    WinTitle = StripNulls(WinTitleBuf)
    
    'Added so text is sent only to chat room and not to pm
    If LCase(WinClass) = LCase(mTargetWinClass) Then
       If InStr(1, WinTitle, " Room", vbTextCompare) <> 0 Then
           frmMain.Combo1.AddItem (WinTitle)
       End If
    End If
    
    FindPalRooms = True
End Function

Public Function ChatHnd(ByVal hwnd As Long, ByVal lParam As Long) As Long
Dim retVal As Long
    mTargetSubClass = "RichEdit20W"
    mTargetSubClassIndex = lParam
    IndexCount = 1
    retVal = EnumChildWindows(hwnd, AddressOf EnumChildProc, lParam)
    ChatHnd = mSubFormHnd
End Function
